posted 5 years ago

i am trying to solve project euler problem 76.

"How many different ways can one hundred be written as a sum of at least two positive integers?"

i tried a recursive approach but i get incorrect answers.

for 5 the answer should be 6. i get answer 7.

for 6 the answer should be 10. i get answer 9.

recursion has never been easy for me and i don't see what i am doing wrong.

this problem should ideally be solved using dynamic programming since the recursive solution will probably be slow, so any suggestions in that regard are welcome also. here is what i have.

"How many different ways can one hundred be written as a sum of at least two positive integers?"

i tried a recursive approach but i get incorrect answers.

for 5 the answer should be 6. i get answer 7.

for 6 the answer should be 10. i get answer 9.

recursion has never been easy for me and i don't see what i am doing wrong.

this problem should ideally be solved using dynamic programming since the recursive solution will probably be slow, so any suggestions in that regard are welcome also. here is what i have.

SCJP

Visit my download page

posted 5 years ago

Recursion and looping is a pretty heady topic to just walk through and figure out what is going wrong wrong. What I would do (were I you) would be:

1) start with a smaller number than 100

2) walk through the process by hand. Write each iteration so I can see how I got to the answer.

3) add print statements so I can see what is being counted in code. Or add break points and run in a debugger so I can look at different values as the code executes.

4) Compare #3 to #2 and see where the mistake is coming from

5) Scale up toe 100.

1) start with a smaller number than 100

2) walk through the process by hand. Write each iteration so I can see how I got to the answer.

3) add print statements so I can see what is being counted in code. Or add break points and run in a debugger so I can look at different values as the code executes.

4) Compare #3 to #2 and see where the mistake is coming from

5) Scale up toe 100.

Steve

posted 5 years ago

that is how i am trying to figure it out. they gave me the answer for 5 and i found the answer for 6 by hand. i have been trying System.out.println but havent figured it out yet. i will keep trying.

SCJP

Visit my download page

Stephan van Hulst

Saloon Keeper

Posts: 7713

141

posted 5 years ago

Randall, recursion becomes much easier if your code is self-documenting. I wouldn't call recurse() a particularly descriptive method name. What problem does it solve?

What if you have a method

That gives the following number of ways to write 7, you just need to add them together:

My implementation of

What if you have a method

`int waysToWrite(int number, int limit)`? It will determine in how many ways you can write number, with none of the terms of the sums exceeding limit. Let's take 7 as an example:7

6 1

5 2

5 1 1

4 3

4 2 1

4 1 1 1

3 3 1

3 2 2

3 2 1 1

3 1 1 1 1

2 2 2 1

2 2 1 1 1

2 1 1 1 1 1

1 1 1 1 1 1 1

That gives the following number of ways to write 7, you just need to add them together:

7:1

6:waysToWrite(1,6)

5:waysToWrite(2,5)

4:waysToWrite(3,4)

3:waysToWrite(4,3)

2:waysToWrite(5,2)

1:waysToWrite(6,1)

My implementation of

`waysToWrite()`didn't use dynamic programming, and took about 10 seconds to come up with the answer for`waysToWrite(100, 99)`. You can add a HashMap that stores answers you already computed in a previous run, which will probably cause the program to come up with the final answer instantaneously.*The mind is a strange and wonderful thing. I'm not sure that it will ever be able to figure itself out, everything else, maybe. From the atom to the universe, everything, except itself.*

Consider Paul's rocket mass heater. |